<?php

namespace Bydedi\Utils\TemplatePlugin;

use Bydedi\Template\AbstractPlugin;
use Detection\MobileDetect;

class DevicePlugin extends AbstractPlugin
{

    /**
     * @var MobileDetect
     */
    protected $mobileDetect;

    /**
     * @param MobileDetect $mobileDetect
     */
    public function __construct(MobileDetect $mobileDetect)
    {
        $this->mobileDetect = $mobileDetect;
    }

    /**
     * @param $params
     * @param $content
     * @param $template
     * @param $repeat
     * @return string
     */
    public function detect($params, $content, $template, &$repeat)
    {
        // only output on the closing tag
        if (!$repeat) {

            switch ($params['type']) {
                case 'desktop':
                    if ($this->mobileDetect->isMobile() == true || $this->mobileDetect->isTablet() == true) {
                        $content = "";
                    }
                    break;
                case 'tablet':
                    if ($this->mobileDetect->isTablet() == false) {
                        $content = "";
                    }
                    break;
                case 'mobile':
                    if ($this->mobileDetect->isMobile() == false || $this->mobileDetect->isTablet() == true) {
                        $content = "";
                    }
                    break;
                default:
                    if ($this->mobileDetect->is($params['type']) == false) {
                        $content = "";
                    }
                    break;
            }

            return $content;
        }
    }

    /**
     * @return array : type / alias used in templating / callback (object, name of the method to call)
     */
    public function register()
    {
        return [
            'block',
            'device',
            array($this, 'detect')
        ];
    }
}
